searchData={"items":[{"type":"module","title":"UAParser","doc":"A fast User Agent parser with a widely used API.","ref":"UAParser.html"},{"type":"function","title":"UAParser.parse/1","doc":"Parse a user-agent string into structs","ref":"UAParser.html#parse/1"},{"type":"function","title":"Examples - UAParser.parse/1","doc":"iex> agent_string = \"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_7; en-us) AppleWebKit/530.17 (KHTML, like Gecko) Version/4.0 Safari/530.17 Skyfire/2.0\"\n    iex> ua = UAParser.parse(agent_string)\n    iex> to_string(ua)\n    \"Skyfire 2.0\"\n    iex> to_string(ua.os)\n    \"Mac OS X 10.5.7\"\n    iex> to_string(ua.device)\n    \"Mac\"","ref":"UAParser.html#parse/1-examples"},{"type":"function","title":"UAParser.parse/2","doc":"","ref":"UAParser.html#parse/2"},{"type":"module","title":"UAParser.Device","doc":"Device struct and helper methods.","ref":"UAParser.Device.html"},{"type":"function","title":"UAParser.Device.__struct__/0","doc":"","ref":"UAParser.Device.html#__struct__/0"},{"type":"function","title":"Examples - UAParser.Device.__struct__/0","doc":"iex> device = %UAParser.Device{family: \"iPhone\"}\n    iex> to_string(device)\n    \"iPhone\"\n\n    iex> device = %UAParser.Device{}\n    iex> to_string(device)\n    \"Other\"","ref":"UAParser.Device.html#__struct__/0-examples"},{"type":"type","title":"UAParser.Device.t/0","doc":"","ref":"UAParser.Device.html#t:t/0"},{"type":"module","title":"UAParser.OperatingSystem","doc":"A module representing an operating System struct.","ref":"UAParser.OperatingSystem.html"},{"type":"function","title":"UAParser.OperatingSystem.__struct__/0","doc":"","ref":"UAParser.OperatingSystem.html#__struct__/0"},{"type":"function","title":"Examples - UAParser.OperatingSystem.__struct__/0","doc":"iex> version = %UAParser.Version{major: \"1\", minor: \"2\"}\n    iex> os = %UAParser.OperatingSystem{family: \"macOS\", version: version}\n    iex> to_string(os)\n    \"macOS 1.2\"\n\n    iex> os = %UAParser.OperatingSystem{family: \"macOS\"}\n    iex> to_string(os)\n    \"macOS\"","ref":"UAParser.OperatingSystem.html#__struct__/0-examples"},{"type":"type","title":"UAParser.OperatingSystem.t/0","doc":"","ref":"UAParser.OperatingSystem.html#t:t/0"},{"type":"module","title":"UAParser.Parser","doc":"Handle parsing the user-agent string.","ref":"UAParser.Parser.html"},{"type":"function","title":"UAParser.Parser.parse/2","doc":"Parse a user-agent string given a set of patterns.","ref":"UAParser.Parser.html#parse/2"},{"type":"behaviour","title":"UAParser.Parsers.Base","doc":"A module representing the base and behaviour for all of our parsers.","ref":"UAParser.Parsers.Base.html"},{"type":"callback","title":"UAParser.Parsers.Base.parse/1","doc":"","ref":"UAParser.Parsers.Base.html#c:parse/1"},{"type":"function","title":"UAParser.Parsers.Base.replace/3","doc":"","ref":"UAParser.Parsers.Base.html#replace/3"},{"type":"macro","title":"UAParser.Parsers.Base.replacement_parser/1","doc":"","ref":"UAParser.Parsers.Base.html#replacement_parser/1"},{"type":"module","title":"UAParser.Parsers.Device","doc":"A parser module representing the device & its relevent information\nof a user agent.","ref":"UAParser.Parsers.Device.html"},{"type":"function","title":"UAParser.Parsers.Device.do_replacement/3","doc":"","ref":"UAParser.Parsers.Device.html#do_replacement/3"},{"type":"function","title":"UAParser.Parsers.Device.parse/1","doc":"Callback implementation for  UAParser.Parsers.Base.parse/1 .","ref":"UAParser.Parsers.Device.html#parse/1"},{"type":"module","title":"UAParser.Parsers.OperatingSystem","doc":"A parser module representing the operating system derived\nfrom a user agent.","ref":"UAParser.Parsers.OperatingSystem.html"},{"type":"function","title":"UAParser.Parsers.OperatingSystem.parse/1","doc":"Callback implementation for  UAParser.Parsers.Base.parse/1 .","ref":"UAParser.Parsers.OperatingSystem.html#parse/1"},{"type":"module","title":"UAParser.Parsers.UA","doc":"A parser module representing the user agent from a request.","ref":"UAParser.Parsers.UA.html"},{"type":"function","title":"UAParser.Parsers.UA.parse/1","doc":"Callback implementation for  UAParser.Parsers.Base.parse/1 .","ref":"UAParser.Parsers.UA.html#parse/1"},{"type":"module","title":"UAParser.Parsers.Version","doc":"A parser module representing the full version of a given\nbrowser derived from the user agent.","ref":"UAParser.Parsers.Version.html"},{"type":"function","title":"UAParser.Parsers.Version.parse/1","doc":"Callback implementation for  UAParser.Parsers.Base.parse/1 .","ref":"UAParser.Parsers.Version.html#parse/1"},{"type":"function","title":"UAParser.Parsers.Version.parse/2","doc":"","ref":"UAParser.Parsers.Version.html#parse/2"},{"type":"module","title":"UAParser.Processor","doc":"Prepare a raw YAML document for consumption by the parser by\nconverting charlists into strings and compiling our patterns.","ref":"UAParser.Processor.html"},{"type":"function","title":"UAParser.Processor.process/1","doc":"Process a document into Elixir keyword lists and compiled patterns.","ref":"UAParser.Processor.html#process/1"},{"type":"module","title":"UAParser.Storage","doc":"Load pattern data at compile time. Recompiling the application is necessary\nafter updating the pattern file.","ref":"UAParser.Storage.html"},{"type":"function","title":"UAParser.Storage.list/0","doc":"","ref":"UAParser.Storage.html#list/0"},{"type":"module","title":"UAParser.UA","doc":"User Agent struct and helper methods.","ref":"UAParser.UA.html"},{"type":"function","title":"UAParser.UA.__struct__/0","doc":"Display the UA as a string.","ref":"UAParser.UA.html#__struct__/0"},{"type":"function","title":"Examples - UAParser.UA.__struct__/0","doc":"iex> version = %UAParser.Version{major: \"1\", minor: \"2\", patch: \"3\", patch_minor: \"4\"}\n    iex> agent = %UAParser.UA{family: \"Family\", version: version}\n    iex> to_string(agent)\n    \"Family 1.2.3.4\"\n\n    iex> agent = %UAParser.UA{family: \"Family\"}\n    iex> to_string(agent)\n    \"Family\"\n\n    iex> agent = %UAParser.UA{}\n    iex> to_string(agent)\n    \"Other\"","ref":"UAParser.UA.html#__struct__/0-examples"},{"type":"type","title":"UAParser.UA.t/0","doc":"","ref":"UAParser.UA.html#t:t/0"},{"type":"module","title":"UAParser.Version","doc":"A module representing user agent version struct and helper methods.","ref":"UAParser.Version.html"},{"type":"function","title":"UAParser.Version.__struct__/0","doc":"","ref":"UAParser.Version.html#__struct__/0"},{"type":"function","title":"Examples - UAParser.Version.__struct__/0","doc":"iex> version = %UAParser.Version{major: \"1\", minor: \"2\", patch: \"3\", patch_minor: \"4\"}\n    iex> to_string(version)\n    \"1.2.3.4\"\n\n    iex> version = %UAParser.Version{major: \"1\", minor: \"2\", patch: \"3\"}\n    iex> to_string(version)\n    \"1.2.3\"\n\n    iex> version = %UAParser.Version{major: \"1\", minor: \"2\"}\n    iex> to_string(version)\n    \"1.2\"\n\n    iex> version = %UAParser.Version{major: \"1\"}\n    iex> to_string(version)\n    \"1\"","ref":"UAParser.Version.html#__struct__/0-examples"},{"type":"type","title":"UAParser.Version.t/0","doc":"","ref":"UAParser.Version.html#t:t/0"},{"type":"extras","title":"License","doc":"# MIT License\n\nCopyright (c) 2024 BEAM Community\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# UAParser\n\n[![Continuous Integration](https://github.com/beam-community/ua_parser/actions/workflows/ci.yaml/badge.svg)](https://github.com/beam-community/ua_parser/actions/workflows/ci.yaml)\n[![Module Version](https://img.shields.io/hexpm/v/ua_parser.svg)](https://hex.pm/packages/ua_parser)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ua_parser/)\n[![Total Download](https://img.shields.io/hexpm/dt/ua_parser.svg)](https://hex.pm/packages/ua_parser)\n[![License](https://img.shields.io/hexpm/l/ua_parser.svg)](https://github.com/beam-community/ua_parser/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/beam-community/ua_parser.svg)](https://github.com/beam-community/ua_parser/commits/master)\n\nA simple, fast user-agent parsing library based on [BrowserScope's](https://ua-profiler.appspot.com/) UA database with a good default dictionary.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"Add `:ua_parser` to your `mix.exs` dependencies:\n\n```elixir\ndef deps do\n  [\n    {:ua_parser, \"~> 1.8\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Overview","doc":"```elixir\niex> ua = UAParser.parse(\"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_7; en-us) AppleWebKit/530.17 (KHTML, like Gecko) Version/4.0 Safari/530.17 Skyfire/2.0\")\n%UAParser.UA{\n  device: %UAParser.Device{family: nil},\n  family: \"Skyfire\",\n  os: %UAParser.OperatingSystem{\n    family: \"Mac OS X\",\n    version: %UAParser.Version{major: \"10\", minor: \"5\", patch: \"7\", patch_minor: nil}\n  },\n  version: %UAParser.Version{major: \"2\", minor: \"0\", patch: nil, patch_minor: nil}\n}\niex> to_string(ua)\n\"Skyfire 2.0\"\niex> to_string(ua.os)\n\"Mac OS X 10.5.7\"\niex> to_string(ua.device)\n\"Other\"\n```\n\nRetrieving and parsing a user-agent string from Plug:\n\n```elixir\nua =\n  conn\n  |> Plug.Conn.get_req_header(\"user-agent\")\n  |> List.first()\n  |> UAParser.parse()\n```","ref":"readme.html#usage"},{"type":"extras","title":"Example - Overview","doc":"There is an example Phoenix application with a simple endpoint/route to retrieve the user agent header.\nTo run it, simply cd into the `example` directory, and run the following:","ref":"readme.html#example"},{"type":"extras","title":"Phoenix - Overview","doc":"```shell\n$ mix do deps.get, compile\n$ npm i && brunch build\n# change the configuration to match your own postgres username/password\n$ mix do ecto.create, ecto.migrate\n$ iex -S mix phoenix.server\n# visit localhost:4000/user_agent\n```","ref":"readme.html#phoenix"},{"type":"extras","title":"Plug - Overview","doc":"It can also be used as a simple plug:\n\n```shell\nmix new ua_plug\ncd ua_plug\n```\n\nAnd now set up `mix.exs`:\n\n```elixir\n# ...\ndefp deps do\n  [\n   {:cowboy, \"~> 1.0.0\"},\n   {:plug, \"~> 1.0\"},\n   {:ua_parser, git: \"https://github.com/beam-community/ua_parser.git\",\n                branch: \"master\"},\n  ]\nend\n# ...\n```\n\nAnd we get our deps and compile:\n\n```shell\nmix do deps.get, compile\n```\n\nAnd now we can make our plug:\n\n```elixir\ndefmodule UAPlug do\n  import Plug.Conn\n\n  def init(options), do: options\n\n  def call(conn, _opts) do\n    ua =\n      conn\n         |> Plug.Conn.get_req_header(\"user-agent\")\n         |> List.first()\n         |> UAParser.parse()\n    send_resp(200, ua)\n  end\nend\n```\n\nFrom here we can pipe requests through it in other applications or use it on its own as we please.","ref":"readme.html#plug"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2016 Sean Callan\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}